# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from xpp_msgs/RobotStateJoint.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import genpy
import geometry_msgs.msg
import sensor_msgs.msg
import std_msgs.msg
import xpp_msgs.msg

class RobotStateJoint(genpy.Message):
  _md5sum = "e95013ef0a2eb2815e5e1a85c92e0ac0"
  _type = "xpp_msgs/RobotStateJoint"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# The state of a robot expressed in the Cartesian frame

duration                time_from_start   # global time along trajectory

# Position, velocity and acceleration of the base expressed in world frame
# The orientation quaternion maps base to world frame.
State6d                 base              # base pos/vel/acc in world

sensor_msgs/JointState  joint_state
bool[]                  ee_contact        # True if the foot is touching the environment




================================================================================
MSG: xpp_msgs/State6d
# The state of the 6D base of a system

geometry_msgs/Pose     pose         # The 6D linear and angular position, orientation maps base to world
geometry_msgs/Twist    twist        # The 6D linear and angular velocity 
geometry_msgs/Accel    accel        # The 6D linear and angular acceleration
================================================================================
MSG: geometry_msgs/Pose
# A representation of pose in free space, composed of position and orientation. 
Point position
Quaternion orientation

================================================================================
MSG: geometry_msgs/Point
# This contains the position of a point in free space
float64 x
float64 y
float64 z

================================================================================
MSG: geometry_msgs/Quaternion
# This represents an orientation in free space in quaternion form.

float64 x
float64 y
float64 z
float64 w

================================================================================
MSG: geometry_msgs/Twist
# This expresses velocity in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: geometry_msgs/Vector3
# This represents a vector in free space. 
# It is only meant to represent a direction. Therefore, it does not
# make sense to apply a translation to it (e.g., when applying a 
# generic rigid transformation to a Vector3, tf2 will only apply the
# rotation). If you want your data to be translatable too, use the
# geometry_msgs/Point message instead.

float64 x
float64 y
float64 z
================================================================================
MSG: geometry_msgs/Accel
# This expresses acceleration in free space broken into its linear and angular parts.
Vector3  linear
Vector3  angular

================================================================================
MSG: sensor_msgs/JointState
# This is a message that holds data to describe the state of a set of torque controlled joints. 
#
# The state of each joint (revolute or prismatic) is defined by:
#  * the position of the joint (rad or m),
#  * the velocity of the joint (rad/s or m/s) and 
#  * the effort that is applied in the joint (Nm or N).
#
# Each joint is uniquely identified by its name
# The header specifies the time at which the joint states were recorded. All the joint states
# in one message have to be recorded at the same time.
#
# This message consists of a multiple arrays, one for each part of the joint state. 
# The goal is to make each of the fields optional. When e.g. your joints have no
# effort associated with them, you can leave the effort array empty. 
#
# All arrays in this message should have the same size, or be empty.
# This is the only way to uniquely associate the joint name with the correct
# states.


Header header

string[] name
float64[] position
float64[] velocity
float64[] effort

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
string frame_id
"""
  __slots__ = ['time_from_start','base','joint_state','ee_contact']
  _slot_types = ['duration','xpp_msgs/State6d','sensor_msgs/JointState','bool[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       time_from_start,base,joint_state,ee_contact

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(RobotStateJoint, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.time_from_start is None:
        self.time_from_start = genpy.Duration()
      if self.base is None:
        self.base = xpp_msgs.msg.State6d()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      if self.ee_contact is None:
        self.ee_contact = []
    else:
      self.time_from_start = genpy.Duration()
      self.base = xpp_msgs.msg.State6d()
      self.joint_state = sensor_msgs.msg.JointState()
      self.ee_contact = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2i19d3I().pack(_x.time_from_start.secs, _x.time_from_start.nsecs, _x.base.pose.position.x, _x.base.pose.position.y, _x.base.pose.position.z, _x.base.pose.orientation.x, _x.base.pose.orientation.y, _x.base.pose.orientation.z, _x.base.pose.orientation.w, _x.base.twist.linear.x, _x.base.twist.linear.y, _x.base.twist.linear.z, _x.base.twist.angular.x, _x.base.twist.angular.y, _x.base.twist.angular.z, _x.base.accel.linear.x, _x.base.accel.linear.y, _x.base.accel.linear.z, _x.base.accel.angular.x, _x.base.accel.angular.y, _x.base.accel.angular.z, _x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs))
      _x = self.joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.position))
      length = len(self.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.velocity))
      length = len(self.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(struct.Struct(pattern).pack(*self.joint_state.effort))
      length = len(self.ee_contact)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(struct.Struct(pattern).pack(*self.ee_contact))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.time_from_start is None:
        self.time_from_start = genpy.Duration()
      if self.base is None:
        self.base = xpp_msgs.msg.State6d()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      end = 0
      _x = self
      start = end
      end += 172
      (_x.time_from_start.secs, _x.time_from_start.nsecs, _x.base.pose.position.x, _x.base.pose.position.y, _x.base.pose.position.z, _x.base.pose.orientation.x, _x.base.pose.orientation.y, _x.base.pose.orientation.z, _x.base.pose.orientation.w, _x.base.twist.linear.x, _x.base.twist.linear.y, _x.base.twist.linear.z, _x.base.twist.angular.x, _x.base.twist.angular.y, _x.base.twist.angular.z, _x.base.accel.linear.x, _x.base.accel.linear.y, _x.base.accel.linear.z, _x.base.accel.angular.x, _x.base.accel.angular.y, _x.base.accel.angular.z, _x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs,) = _get_struct_2i19d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.position = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.velocity = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.effort = s.unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.ee_contact = s.unpack(str[start:end])
      self.ee_contact = list(map(bool, self.ee_contact))
      self.time_from_start.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2i19d3I().pack(_x.time_from_start.secs, _x.time_from_start.nsecs, _x.base.pose.position.x, _x.base.pose.position.y, _x.base.pose.position.z, _x.base.pose.orientation.x, _x.base.pose.orientation.y, _x.base.pose.orientation.z, _x.base.pose.orientation.w, _x.base.twist.linear.x, _x.base.twist.linear.y, _x.base.twist.linear.z, _x.base.twist.angular.x, _x.base.twist.angular.y, _x.base.twist.angular.z, _x.base.accel.linear.x, _x.base.accel.linear.y, _x.base.accel.linear.z, _x.base.accel.angular.x, _x.base.accel.angular.y, _x.base.accel.angular.z, _x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs))
      _x = self.joint_state.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      length = len(self.joint_state.name)
      buff.write(_struct_I.pack(length))
      for val1 in self.joint_state.name:
        length = len(val1)
        if python3 or type(val1) == unicode:
          val1 = val1.encode('utf-8')
          length = len(val1)
        buff.write(struct.Struct('<I%ss'%length).pack(length, val1))
      length = len(self.joint_state.position)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.position.tostring())
      length = len(self.joint_state.velocity)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.velocity.tostring())
      length = len(self.joint_state.effort)
      buff.write(_struct_I.pack(length))
      pattern = '<%sd'%length
      buff.write(self.joint_state.effort.tostring())
      length = len(self.ee_contact)
      buff.write(_struct_I.pack(length))
      pattern = '<%sB'%length
      buff.write(self.ee_contact.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.time_from_start is None:
        self.time_from_start = genpy.Duration()
      if self.base is None:
        self.base = xpp_msgs.msg.State6d()
      if self.joint_state is None:
        self.joint_state = sensor_msgs.msg.JointState()
      end = 0
      _x = self
      start = end
      end += 172
      (_x.time_from_start.secs, _x.time_from_start.nsecs, _x.base.pose.position.x, _x.base.pose.position.y, _x.base.pose.position.z, _x.base.pose.orientation.x, _x.base.pose.orientation.y, _x.base.pose.orientation.z, _x.base.pose.orientation.w, _x.base.twist.linear.x, _x.base.twist.linear.y, _x.base.twist.linear.z, _x.base.twist.angular.x, _x.base.twist.angular.y, _x.base.twist.angular.z, _x.base.accel.linear.x, _x.base.accel.linear.y, _x.base.accel.linear.z, _x.base.accel.angular.x, _x.base.accel.angular.y, _x.base.accel.angular.z, _x.joint_state.header.seq, _x.joint_state.header.stamp.secs, _x.joint_state.header.stamp.nsecs,) = _get_struct_2i19d3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.joint_state.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.joint_state.header.frame_id = str[start:end]
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.joint_state.name = []
      for i in range(0, length):
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        start = end
        end += length
        if python3:
          val1 = str[start:end].decode('utf-8', 'rosmsg')
        else:
          val1 = str[start:end]
        self.joint_state.name.append(val1)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.position = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.velocity = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sd'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.joint_state.effort = numpy.frombuffer(str[start:end], dtype=numpy.float64, count=length)
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      pattern = '<%sB'%length
      start = end
      s = struct.Struct(pattern)
      end += s.size
      self.ee_contact = numpy.frombuffer(str[start:end], dtype=numpy.bool, count=length)
      self.ee_contact = list(map(bool, self.ee_contact))
      self.time_from_start.canon()
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2i19d3I = None
def _get_struct_2i19d3I():
    global _struct_2i19d3I
    if _struct_2i19d3I is None:
        _struct_2i19d3I = struct.Struct("<2i19d3I")
    return _struct_2i19d3I
